# Tejas-Java (JikeRVM)

Tejas Java is an architectural simulator to analyze java programs. It uses JikesRVM to get the instruction trace, and supports class compiled using, upto Java-6.

**Note:** This is a plugin for Tejas, which is require for the functionality.
This plugin gets the trace of a Java program. However, to analyze the trace to Tejas is reuiqred, which can de downloded from [Tejas](http://www.cse.iitd.ac.in/tejas/)

-----------------

 A complete README file on how to use Tejas-Java can be found here:  [Tejas-Java Documentation](docs/tejas-java.pdf)

## HOW TO setup Tejas-Java

### Pre-Requisite
 * Ant
 * Mercurial
 * gcc
 * gcc-multilib
 * g++-multilib
 * Bison
 * Perl
 * Awk

### Folder Structure
The folder is a clone of JikesRVM with added instrumented code to get the trace of the Java program. There are two folders inside this:
- **rvm_singlethread**
- **rvm_multithread**

As the name indicates, these folder to be used when using benchmarks of single and multiple thread respectively. In practise, any of the folders can be used to run any benchmark. However, rvm_multithread has special code, which marks instruction from different threads separately, so that each of the threads can be analyzed independently.

As per the need, rename the folder to **rvm**, which is the name of the expected folder while building jikes.

For single thread benchmark:  
``
mv rvm_singlethread rvm
``  
  and for multiple thread  use:  
``
mv rvm_multithread rvm
``

### Build Commands
After renaming, configure the the java version.  
build has been tested on openjdk-6 and openjdk-7  
Configure approriate java version using command:  
``
vim bin/buildit.base_config
``  
and setting approriate Java version:

````
global.javahome.ppc32-linux=/opt/ibm-java2-ppc-50
global.javahome.ppc64-linux=/opt/ibm-java2-ppc-50
global.javahome.ia32-linux=/opt/jdk1.6.0  
global.javahome.x86_64-linux=/usr/lib/jvm/java-6-openjdk  
global.javahome.ia32-osx=/System/Library/Frameworks/JavaVM.framework/Home  
global.javahome.x86_64-osx=/System/Library/Frameworks/JavaVM.framework/Home  
````  
After this run:  
``
bin/buildit localhost development
``  
This will create folder inside dist, which will contain the required binary files.  
Please refer to [Tejas-Java Documentation](docs/tejas-java.pdf) for more details.
